var bitmapSelectionRect;

var _Utils = (function () {

	var originalScreenSelRect;
	
	function init(){
		originalScreenSelRect = null;
	}
	function chunks(array, size) {
	  var workingArray = array.slice(0);
	  var results = [];
	  while (workingArray.length) {
		results.push(workingArray.splice(0, size));
	  }
	  return results;
	};

	function normaliseRect(rect)
	{
		if (rect != null && rect != undefined)
		{
			if (rect.height < 0)
			{
				rect.row += rect.height;
				rect.height *= -1; 
			}
			if (rect.width < 0)
			{
				rect.col += rect.width;
				rect.width *= -1; 
			}
		}
		return rect;
		}

		function getScreenSelectionRect(){
			if (originalScreenSelRect == null)
				originalScreenSelRect = doGetScreenSelectionRect();
			return originalScreenSelRect;
		}
		
		function doGetScreenSelectionRect()
		{
			// Find the char in from the selection from the current mouse position in the bitmap
			var selRect = CbmScreen.getSelectionRect();
			if (selRect != null && selRect != undefined)
				normaliseRect(selRect);

			selRect.width++;
			selRect.height++;
			return selRect;
		}

		function splitArray(bigarray, size){
			var splicedArray = [];
			for (var i=0; i<bigarray.length; i+=size) {
				var smallarray = bigarray.slice(i,i+size);
				splicedArray.push(smallarray);
			}
			return splicedArray;
		}

		function combineChunks(arrayOfArrays){
			var arr = [];
			for(var i =0; i < arrayOfArrays.length; i++){
				for(var j =0; j < arrayOfArrays[i].length; j++){
					arr.push(arrayOfArrays[i][j]);
				}	
			}
			return arr;
		}

	   return {
			getScreenSelectionRect : getScreenSelectionRect,
			chunks : chunks,
			init : init,
			splitArray : splitArray,
			combineChunks : combineChunks
		};
	
})();	var _BitmapCopyBuffer = (function () {
	
	var bitmapbuffer = [];	
	var revertbuffer = [];	
	
	function copySelection(bitmapbuffer){

		var sr = bitmapSelectionRect;
		if (!sr) return;
		
		bitmapbuffer.length=0;
		
		var startRow = sr.row;
		var startcol = sr.col;
		var endRow = startRow + sr.height;
		var endCol = startcol + sr.width;		
		
		// Push metadata...
		bitmapbuffer.push({width: sr.width, height: sr.height});
		
		for (var row = startRow; row < endRow; row++){
				
				for (var col = startcol; col < endCol; col++) {
					
					// get index into screen selection rect
					var selectionCharColIndex = Math.floor(col / 8);
					var selectionCharRowIndex = Math.floor(row / gCharHeight);
					var selectionCharColPixel = col % 8;
					var selectionCharRowPixel = row % gCharHeight;
					
					var charSelRect = _Utils.getScreenSelectionRect();
					var charSelRow = charSelRect.row + selectionCharRowIndex;
					var charSelCol = charSelRect.col + selectionCharColIndex;
					
					var charIndex = CbmScreen.getCharFromRowCol(charSelRow, charSelCol);	
					var screenChar = uDCGen.getCbmChar(charIndex);
					var copiedBit = screenChar.getBit(selectionCharRowPixel, selectionCharColPixel);
					bitmapbuffer.push(copiedBit);		
				}
			}
	
	};

	
	
	function pasteSelection(bitmapbuffer){

		var sr = bitmapSelectionRect;
		if (!sr) return;
		if (!bitmapbuffer) return;
		
		var pasteBuffer = bitmapbuffer.slice(0);
		var header = pasteBuffer.shift();
		
		var startRow = sr.row;
		var startcol = sr.col;
		var endRow = startRow + header.height;
		var endCol = startcol + header.width;	
		
		for (var row = startRow; row < endRow; row++){
				
				for (var col = startcol; col < endCol; col++) {
					
					// get index into screen selection rect
					var selectionCharColIndex = Math.floor(col / 8);
					var selectionCharRowIndex = Math.floor(row / gCharHeight);
					var selectionCharColPixel = col % 8;
					var selectionCharRowPixel = row % gCharHeight;
					
					var charSelRect = _Utils.getScreenSelectionRect();
					var charSelRow = charSelRect.row + selectionCharRowIndex;
					var charSelCol = charSelRect.col + selectionCharColIndex;
					
					var charIndex = CbmScreen.getCharFromRowCol(charSelRow, charSelCol);	
					var screenChar = uDCGen.getCbmChar(charIndex);
					var copiedBit = pasteBuffer.shift();
					screenChar.setBit(selectionCharRowPixel, selectionCharColPixel,copiedBit);
				}
			}
	
		var x = 1;
	}
	

   return {
		copySelection : copySelection,
		pasteSelection : pasteSelection,
		bitmapbuffer : bitmapbuffer,
		revertbuffer : revertbuffer
    };
	
})();	
	
var _BitMapWindowManager = (function () {

	// Shared globals
	var clientPixelRatioX = 1;
	var dlgCursorMode = 0;
	var lastParentHeight = $('#dialogContainer').height();
	var lastPparentWidth = $('#dialogContainer').width();
	
	setInterval (function () {

		var parentHeight = $('#dialogContainer').height();
		var parentWidth = $('#dialogContainer').width();

		if (lastParentHeight != parentHeight || lastPparentWidth != parentWidth) {
			$('#bitMapCanvas').height(parentHeight - 340);
			$('#bitMapCanvas').width(parentWidth - 60);
			lastParentHeight =  $('#dialogContainer').height();
			lastPparentWidth = $('#dialogContainer').width();
		}

	}, 1000);	

	function getMouseCharPosEx(e) {

		// hardcodes in HTML
		var originalCanvasHeight = 350;
		var originalCanvasWidth = 480;	
		
		var canvas = e.target;
		//var coords = getCursorPosition	(e);
		var coords = {x:e.clientX, y: e.clientY};
		var offSetCanvas = $("#bitMapCanvas").offset();
		coords.x -= offSetCanvas.left;
		coords.y -= offSetCanvas.top;

		var curCanvasWidth = $('#bitMapCanvas').width();
		var curCanvasHeight = $('#bitMapCanvas').height();
		var xScale =  curCanvasWidth / originalCanvasWidth;
		var yScale =  curCanvasHeight / originalCanvasHeight;
		
		var scaledWidth = canvas.width * xScale;
		var scaledHeight = canvas.height * yScale;

		var selRect = _Utils.getScreenSelectionRect();	
		var scaleAxis = Math.min(curCanvasWidth, curCanvasHeight);
		_BitMapWindowManager.clientPixelRatioX = scaleAxis / 1200;
		
		var col = coords.x / scaledWidth * selRect.width;
		var row = coords.y / scaledHeight * selRect.height;

		var colInt = Math.floor(col);
		var rowInt = Math.floor(row);

		var rowPixel = (row - rowInt) * gCharHeight;
		var colPixel = (col - colInt) * 8;

		rowPixel =  Math.floor(rowPixel);
		colPixel =  Math.floor(colPixel);
		
		var pixelX = (colInt * 8) + colPixel;
		var pixelY = (rowInt * gCharHeight) + rowPixel;
		
		return {row:rowInt, col:colInt, colPixel:colPixel, rowPixel:rowPixel, pixelX : pixelX, pixelY : pixelY};
	
	}

   return {
		getMouseCharPosEx : getMouseCharPosEx,
		clientPixelRatioX : clientPixelRatioX
    };
	
})();	




var _BitMapEditor = (function () {

	var canvas = $("#bitMapCanvas")[0];
	var mouseCaptured = false;
	var initialMousePos = null;
	
	function onShown() {
		_Utils.init();	
		$('#btcdlgModeDraw').trigger('click');
		$('#btcdlgModeSel').trigger('click');
		_BitMapEditor.drawBitmapScreen();		
		var selRect = _Utils.getScreenSelectionRect();	
		setBitmapSelectionRect(0,0, (selRect.width * 8) -1 , (selRect.height * gCharHeight) -1);
		_BitmapCopyBuffer.copySelection(_BitmapCopyBuffer.revertbuffer);
		setBitmapSelectionRect(-1,-1,0,0);
	}
	
	function drawBitmapScreen(rowHint, colHint, charHint, useSelRect) {

		var showCharGrid = $("#chkdlgCharGrid").is(':checked');
		var showPixelGrid = $("#chkdlgPixelGrid").is(':checked');
		
		var context = canvas.getContext("2d");
		var selRect = _Utils.getScreenSelectionRect();	

		// Selection rect is not inclusive
		prepareCanvas(canvas, context, selRect.width * 8, selRect.height * gCharHeight);
		//context.clearRect(0, 0, canvas.width, canvas.height);

		// Take a copy of global fill colours
		var fillStyles = gmcFillStyles.slice(0); 
		var startRow = selRect.row;
		var startcol = selRect.col;
		var endRow = startRow + selRect.height;
		var endCol = startcol + selRect.width;
		
		for (var row = startRow; row < endRow; row++){
			
			var targetRow = row - startRow; 
			if (rowHint != undefined && rowHint != targetRow)
				continue;

			for (var col = startcol; col < endCol; col++) {

				var targetCol = col - startcol; 
				if (colHint != undefined && colHint != targetCol)
					continue;
				
				var pos = CbmScreen.getCoOrdsAt(targetRow, targetCol);
				var screenChar = CbmScreen.getCharFromRowCol(row,col);
				
				// Restrict by char hint
				if (charHint != undefined && charHint != screenChar)
					continue;
				
				var screenColorIndex = CbmScreen.getCharColourFromRowCol(row, col);
				
				// Work out if supposed to be multicolour
				var mc = screenColorIndex & 8;
				
				// Mask out multi colour bit for select first 8 characters
				screenColorIndex = screenColorIndex & ~8;
				
				// Pick correct char colour from  drop down based on screen colour
				var colorStyle = gCharColours[screenColorIndex];
				
				// Store in styles array
				fillStyles[2] = [colorStyle];

				//console.log("drawing at:" + pos.x  + "," + pos.y + " char= " + screenChar);
				context.clearRect(pos.x, pos.y, 8, gCharHeight);
				var cbmChar = uDCGen.getCbmChar(screenChar);
				blitCharBits(mc, showPixelGrid, fillStyles, canvas, context, cbmChar, pos.x, pos.y, 8, gCharHeight);
				
				if (showCharGrid)
				{
					context.strokeStyle="grey";
					context.lineWidth=.16;
					context.strokeRect(pos.x, pos.y, 8, gCharHeight);
				}
			}
		}

		// If to display a selected cell
		if (!dlgCursorMode)
		{
			var sr = bitmapSelectionRect;
			context.strokeStyle="gold";
			context.lineWidth= _BitMapWindowManager.clientPixelRatioX;
			if (sr && (sr.width >= 0 && sr.height >= 0))
				context.strokeRect(sr.col, sr.row, sr.width, sr.height);
		}			
	}


	// return char by coords
    var setBitmapSelectionRect = function (row,col,width,height) {
		bitmapSelectionRect = {row:row, col:col, width: width+1, height:height+1};
    };



	// ScreenGrid mode handler
	$('#chkdlgCharGrid,#chkdlgPixelGrid').click(function(e) {
		drawBitmapScreen();
	});
	
	// ScreenGrid mode handler
	$('#bdlgCopy').click(function(e) {
		_BitmapCopyBuffer.copySelection(_BitmapCopyBuffer.bitmapbuffer);
	});

	// ScreenGrid mode handler
	$('#bdlgPaste').click(function(e) {
		
		_BitmapCopyBuffer.pasteSelection(_BitmapCopyBuffer.bitmapbuffer);
		drawBitmapScreen();
		RedrawScreen();
	});	

	$('#bdlgRevertAll').click(function(e) {
		$('#bdlgSelectAll').trigger('click');
		$('#bdlgRevert').trigger('click');
	});		

	// ScreenGrid mode handler
	$('#bdlgRevert').click(function(e) {

		var sr = bitmapSelectionRect;
		if (!sr) return;

		var sBuf = _BitmapCopyBuffer.revertbuffer.slice(0);
		var sBufHeader = sBuf.shift();
			
		var rows = _Utils.chunks(sBuf, sBufHeader.width);
		var srBottom = sr.row + sr.height;
		var srRight = sr.col + sr.width;
		var newrows = [];
		
		for (var sourceRow =0; sourceRow < rows.length; sourceRow++)
		{
			if (sourceRow < sr.row || sourceRow >= srBottom)
				continue;
			
			var sRow = rows[sourceRow];
			for (var sourceCol = 0; sourceCol < sRow.length; sourceCol++)
			{
				if (sourceCol < sr.col || sourceCol >= srRight)
					continue;
				newrows.push(sRow[sourceCol]);
			}
		}
		newrows.unshift({width: sr.width, height: sr.height});
		_BitmapCopyBuffer.pasteSelection(newrows);
		drawBitmapScreen();
		RedrawScreen();
		
	});		
	
	// ScreenGrid mode handler
	$('#bdlgClear').click(function(e) {
		
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var length = buffer.length;
		for (var i = 1; i < length; i++)
			buffer[i]=0;
		_BitmapCopyBuffer.pasteSelection(buffer);
		drawBitmapScreen();
		RedrawScreen();
		
	});	

	// ScreenGrid mode handler
	$('#bdlgIvert').click(function(e) {
		
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var length = buffer.length;
		for (var i = 1; i < length; i++)
			buffer[i]=!buffer[i];
		_BitmapCopyBuffer.pasteSelection(buffer);
		drawBitmapScreen();
		RedrawScreen();
		
	});	

	// ScreenGrid mode handler
	$('#bdlgFlipHorz').click(function(e) {
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		var newrows = [];
		for(var i =0; i < rows.length; i++)
		{
			var newRow	= rows[i].reverse();;
			newrows.push(newRow);
		}
		
		var newbuffer = newrows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
		
	});	
	
	
	
	function splitArray(bigarray, size){
		var splicedArray = [];
		for (var i=0; i<bigarray.length; i+=size) {
			var smallarray = bigarray.slice(i,i+size);
			splicedArray.push(smallarray);
		}
		return splicedArray;
	}

	function combineChunks(arrayOfArrays){
		var arr = [];
		for(var i =0; i < arrayOfArrays.length; i++){
			for(var j =0; j < arrayOfArrays[i].length; j++){
				arr.push(arrayOfArrays[i][j]);
			}	
		}
		return arr;
	}

	// ScreenGrid mode handler
	$('#bdlgFlipHorzMC').click(function(e) {
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		var newrows = [];
		for(var i =0; i < rows.length; i++)
		{
			var row	= rows[i];
			var revRow	= splitArray(row, 2);
			var reversedNewRow = revRow.reverse();
			var newRow = combineChunks(reversedNewRow);
			newrows.push(newRow);
		}
		
		var newbuffer = newrows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
		
	});		
	
	// ScreenGrid mode handler
	$('#bdlgFlipVert').click(function(e) {
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		var newrows = rows.reverse();
		var newbuffer = newrows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
		
	});	
	
	// ScreenGrid mode handler
	$('#bdlgShiftUp').click(function(e) {
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		var firstRow = rows.shift();
		rows.push(firstRow);
		var newbuffer = rows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
	});	
	
	// ScreenGrid mode handler
	$('#bdlgShiftDown').click(function(e) {
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		var lastRow = rows.pop();
		rows.unshift(lastRow);
		var newbuffer = rows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
	});	

	// ScreenGrid mode handler
	$('#bdlgShiftLeft').click(function(e) {
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		for (var row=0; row < rows.length; row++) RotateLeft(rows[row]);
		var newbuffer = rows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
	});	

	// ScreenGrid mode handler
	$('#bdlgShiftRight').click(function(e) {
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		for (var row=0; row < rows.length; row++) RotateRight(rows[row]);
		var newbuffer = rows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
	});	

	
	// ScreenGrid mode handler
	$('#bdlgSelectAll').click(function(e) {
		var selRect = _Utils.getScreenSelectionRect();	
		setBitmapSelectionRect(0,0, (selRect.width * 8) -1 , (selRect.height * gCharHeight) -1);
		drawBitmapScreen();
	});		

	function revHelper(a){
	  for (i in a){
		a[i] = a[i].reverse();
	  }
	  return a;
	  }
	
	function rotate90(a){
	  a = Object.keys(a[0]).map(function (c) { return a.map(function (r) { return r[c]; }); });
	  a = revHelper(a);
	  return a;
	}

	function rotateNeg90(a){
	  a = revHelper(a);
	  a = Object.keys(a[0]).map(function (c) { return a.map(function (r) { return r[c]; }); });
	  return a;
	}	

	// ScreenGrid mode handler
	$('#bdlgRotRight, #bdlgRotLeft').click(function(e) {
		
		var target = $(e.target);
		var buffer = [];
		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		if (header.width != header.height)
		{
			alert("Only square selections can be rotated - hold down ctrl key and re-select an area.");
			return;
		}
		var rows = _Utils.chunks(buffer, header.width);
		var newrows;
		if(target.is('#bdlgRotRight'))
			newrows = rotate90(rows);
		else
			newrows = rotateNeg90(rows);
		
		var newbuffer = newrows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		drawBitmapScreen();
		RedrawScreen();
		
	});



	var lastPosition = null;
	function proceessCharMouseMove(e) {
		if (mouseCaptured )
		{
			var coords = _BitMapWindowManager.getMouseCharPosEx(e);
			
			if (lastPosition)
			{
				if ((coords.rowPixel == lastPosition.rowPixel) && (coords.colPixel == lastPosition.colPixel))
					return;
			}
			lastPosition = coords;

			// Find the char in from the selection from the current mouse position in the bitmap
			var rect = _Utils.getScreenSelectionRect();	
			var screenRow = rect.row + coords.row;
			var screenCol = rect.col + coords.col;
			
			// Obtain the char object in the buffer
			var charIndex = CbmScreen.getCharFromRowCol(screenRow, screenCol);
			var charColour = CbmScreen.getCharColourFromRowCol(screenRow, screenCol);
			var cbmChar = uDCGen.getCbmChar(charIndex);
			cbmChar.invalidateCanvas();
			
			// Toggle is always false for bitmap viewer...
			var toggleMode  = false;         
			
			// For now take the colour register from the char screen...
			var colReg = $("#mcDIV input[type='radio']:checked").val();

			// Intended multiocolor comes from whether the char on screen is multi-color
			var intendedMultiColour = CbmScreen.getCellMultiColourMode(screenRow, screenCol); 

			// Calculate size of selection
			var selWidth = coords.pixelX - initialMousePos.pixelX;
			var selHeight = coords.pixelY - initialMousePos.pixelY;			
				
			switch(dlgCursorMode)
			{
				case 0:
						if (e.ctrlKey) {
							selWidth = Math.min(selWidth, selHeight);
							selHeight = Math.min(selWidth, selHeight);
						}
				
						setBitmapSelectionRect(initialMousePos.pixelY, initialMousePos.pixelX, selWidth, selHeight);
						//console.log (pos.row,pos.col,width,height);
						drawBitmapScreen(undefined, undefined, undefined, true);
						//var cusText = "" + mouseDownPos.row + "," + mouseDownPos.col + " (" + (width+1) + ":" + (height+1) + ")";
						//$("#cursorPos").text(cusText);
						break;

					case 1:

						// Right mouse button = background
						if (mouseDownEvent.which === 3)
							colReg = 0;
			
						if (e.ctrlKey) {
							if ((coords.pixelX != initialMousePos.pixelX) && (coords.pixelY != initialMousePos.pixelY))
								return;
						}

						// Draw the apropriate column in the character canvas...
						//function proceessCharMouseMove(canvas, row, col, charIndex, colorRegister, toggleMode, intendedCharColour) {
						doCharCanvasProceessCharMouseMove(coords.rowPixel, coords.colPixel, charIndex, colReg, toggleMode, intendedMultiColour, charIndex);
						drawBitmapScreen(undefined, undefined, charIndex);
						break;
			}
		}
	}




	$("#bitMapCanvas").mousemove(function(e) {
		//console.log("mousemove");
		proceessCharMouseMove(e);
	});

	$("#bitMapCanvas").mousedown(function(e) {
		//console.log("mousedown");
		mouseCaptured = true;
		mouseDownEvent = e;
		initialMousePos = _BitMapWindowManager.getMouseCharPosEx(e);
		proceessCharMouseMove(e);
	});

	$("#bitMapCanvas").mouseleave(function(e) {
		//console.log("mouseleave");
		mouseCaptured = false;
	}); 

	$("#bitMapCanvas").mouseup(function(e) {
		//console.log("mouseup");
		lastPosition = null;
		if (mouseCaptured)
		{
			proceessCharMouseMove(e);
		}
		mouseCaptured = false;
	});	
	
	// Select mode handler
	$('#dlgCursorMode input').change(function() {
		dlgCursorMode = parseInt($(this).val());
		setBitmapSelectionRect(-1,-1,0,0);
	});

	return {
		drawBitmapScreen : drawBitmapScreen,
		onShown: onShown
    };
	
})();

// Disable context menu
$('#bitMapCanvas').bind('contextmenu', function(e){
    return false;
}); 


var _selectedImg = null;	
var _selectedImgPath = null;	

var _BitMapImporter = (function () {


	// Organise all chars
	$('#pasteImageToSelection').click(function(e) {
		pasteImageData();
	});




	function findColourIndex(pal, red, green, blue){
		for (index =0; index < pal.length; index++){
			var palEntry = pal[index];
			if (palEntry[0] == red && palEntry[1] == green && palEntry[2] == blue)
				return index;
		}
		throw "Colour not found";
	}
	
	function findBitmapColorIndex(imageData, targetWidth, x, y){
		var index = 4 * (targetWidth*y+x);
		var r = imageData[index];
		var g = imageData[index+1];
		var b = imageData[index+2];
		var colorIndex = findColourIndex(pal, r,g,b);
		return colorIndex;
	}



	// Called to process the image
	function pasteImageData(){

		if (!ensureSelection()) return false;
		reduceImage();

		img = getImage();
		var sr = bitmapSelectionRect;
		var colorDepth = 2;
		var targetWidth = sr.width;
		var targetHeight = sr.height;
		var isMC  =  isMultiColorUsed();
		var stepping = 1;

		if (isMC)  
		{
			targetWidth = sr.width / 2;
			colorDepth = 4;		
			stepping = 2;
		}
		
		var dithKernalSelection =  $('#dithKernSelector').val();        // dithering kernel name, see available kernels in docs below
		var dithSerpOpt =  $('dithSerp').find('option:selected').val();
		var histogramMethodOpt  =  $('#histogramMethod').val();       
		var colorDistOpt  =  $('#colorDist').val();       

		// Then quantize it down to four colours
		// options with defaults (not required)
		var opts = {
			colors: colorDepth,             // desired palette size
			minHueCols: 8192,     // # of colors per hue group to evaluate regardless of counts, to retain low-count hues
			dithKern: dithKernalSelection,        // dithering kernel name, see available kernels in docs below
			dithSerp: dithSerpOpt,       // enable serpentine pattern dithering
			//method:histogramMethodOpt,
			colorDist: colorDistOpt
		};		
		
		// Sample down to 4 colours	
		q = new RgbQuant(opts);
		q.sample(vicCanvas);
		pal = q.palette(true);
		var imageData = q.reduce(vicCanvas);

		var mcmapLOBIT = [0,0,1,1];
		var mcmapHIBIT = [0,1,0,1];
		var buffer = [];

		_BitmapCopyBuffer.copySelection(buffer);
		var header = buffer.shift();
		var rows = _Utils.chunks(buffer, header.width);
		var newrows = [];
		for(var iRow =0; iRow < rows.length; iRow++)
		{
			var row	= rows[iRow].slice(0);
			// Paste in as multicolor
			// Set pixels from the bitmap
			for (var pixel = 0; pixel < (row.length / stepping); pixel++)	{
				var colIndex = findBitmapColorIndex(imageData, targetWidth, pixel, iRow);
				var tgtPixel = pixel * stepping;
				if (isMC) {
					row[tgtPixel] = mcmapLOBIT[colIndex];
					row[tgtPixel+1] = mcmapHIBIT[colIndex];
				}
				else{
					row[tgtPixel] = colIndex;
				}
			}
			newrows.push(row);
		}
		
		var newbuffer = newrows.reduce(function(a, b){return a.concat(b)});
		newbuffer.unshift(header);
		
		_BitmapCopyBuffer.pasteSelection(newbuffer);
		_BitMapEditor.drawBitmapScreen();
		RedrawScreen();
	}

	// Called to process the image
	function reduceImage(img){

		img = getImage();
		var sr = bitmapSelectionRect;
		var targetWidth = sr.width;
		var isMC  =  isMultiColorUsed();
		var targetWidth = sr.width;
		var targetHeight = sr.height;

		if (isMC)  {
			targetWidth = sr.width / 2;
		}
			
		// First resize the image to the selection
		var vicCanvas = document.getElementById("vicCanvas");
		vicCanvas.width = targetWidth;
		vicCanvas.height = targetHeight;
		
		// Reduces the image to the vicCanvas without blocking as a preview
		resample_af(img, vicCanvas, img.width, img.height, targetWidth, targetHeight);

	}

	
	// Method handlers
	$('#btnChooseImage').click(function(e) {
		if (!checkMCSelection()){
			e.preventDefault();
			return false;
		} 
		var randomString = Math.random().toString(36).substring(7);
		$(this).attr("value", randomString); 
	});

	// Method handlers
	$('#btnChooseImage').change(function(e) {

		var URL = window.webkitURL || window.URL;
		var url = URL.createObjectURL(e.target.files[0]);
		var img = new Image();
		img.src = url;
		img.onload = function() {
			_selectedImgPath = e.target.files[0];		
			// Load the image
			var imagePreviewCanvas = document.getElementById("imagePreviewCanvas");
			var ctx = imagePreviewCanvas.getContext("2d");
			ctx.drawImage(img, 0, 0, imagePreviewCanvas.width, imagePreviewCanvas.height);
			// ctx.drawImage(img, 0, 0, 1000, 1000);
			_selectedImg = img;
		}
	});

	function getImage(){
		return _selectedImg;
	}
	function ensureSelection(){

		var sr = bitmapSelectionRect;
		if (sr && (sr.width < 4 || sr.height < 4))
		{
			alert ("Please make a selection before importing");
			return false;
		}
		return true;

	}

	function isMultiColorUsed(){
		var rect = _Utils.getScreenSelectionRect();	
		return CbmScreen.getCellMultiColourMode(rect.row, rect.col); 
	}

	function checkMCSelection(){
		var intendedMultiColour=null;
		// Find the char in from the selection from the current mouse position in the bitmap
		var rect = _Utils.getScreenSelectionRect();	
		for (var row =0; row < rect.height; row++){
			for (var col =0; col < rect.width; col++){
				var newIntendedMultiColour = CbmScreen.getCellMultiColourMode(rect.row + row, rect.col + col); 
				if (intendedMultiColour==null){
					intendedMultiColour = newIntendedMultiColour;
					continue;
				}
				if (intendedMultiColour != newIntendedMultiColour){
					alert("All characters in selection must be have the same multicolor setting");
					return false;
				}
			}
		}
		return true;
	}
   return {
    };
	
})();	



