// cbmChar class - Revealing prototype pattern
var cbmChar = function (index, charData) {

    // Allocate an array to hold the UDC data
    this.cbmCharRows = [];

    // Private methods....
	if (index == null)
		index = 32;

	this.charIndex = index;
	this._Canvas = null;
	
    for (var i = 0; i < gCharHeight; i++)
	{
        this.cbmCharRows.push(charData[this.charIndex*gCharHeight+i]);
	}
	
	// Used to store pallete attributes
	this.IntendedMultiColor = false;
	this.IntendedCharColor = 6;// Blue
};

// Set the copy buffer
var cbmCharCopy = new cbmChar(0, cbmCharData);

cbmChar.prototype = function() {

	// Rows accessor
	var Index = function () {return this.charIndex};
	
	// Rows accessor
	var rows = function () {return this.cbmCharRows};

	// Rows accessor
	var row = function (index) {return this.cbmCharRows[index]};

	// Rows accessor
	var Canvas =   function () {
		if (!this._Canvas){
			this._Canvas = document.createElement('canvas');
			this._Canvas.style.imageRendering = 'pixelated';
			this._Canvas.width = 0;
			this._Canvas.height = 0;
		}
		return this._Canvas;
	};
	
	// copy..
    var setData = function (charData) {
		this.cbmCharRows = [];
		for (var i = 0; i < gCharHeight; i++)
		{
			this.cbmCharRows.push(charData[i]);
		}
     };
	 
	// copy..
    var clone = function () {
		invalidateCanvas();
		var clonedChar = new cbmChar(this.charIndex , cbmCharData);
		
		// Reset the copy buffer
		for (var i=0; i < gCharHeight; i++)
		{
			clonedChar.cbmCharRows[i] = this.cbmCharRows[i];
		}
		// Memberwise copy
		clonedChar.IntendedMultiColor = this.IntendedMultiColor;
		clonedChar.IntendedCharColor = this.IntendedCharColor;
		return clonedChar;
     };

	// copy..
    var copy = function () {
		
		// Reset the copy buffer
		for (var i=0; i < gCharHeight; i++)
		{
			cbmCharCopy.cbmCharRows[i] = this.cbmCharRows[i];
		}
		// Memberwise copy
		cbmCharCopy.IntendedMultiColor = this.IntendedMultiColor;
		cbmCharCopy.IntendedCharColor = this.IntendedCharColor;
		
     };

	// paste..
    var paste = function () {
		if (cbmCharCopy.cbmCharRows.length > 0)
		{
			for (var i=0; i < gCharHeight; i++)
			{
				this.cbmCharRows[i] = cbmCharCopy.cbmCharRows[i];
			}
		}

		// Memberwise copy
		this.IntendedMultiColor = cbmCharCopy.IntendedMultiColor;
		this.IntendedCharColor = cbmCharCopy.IntendedCharColor;

	};	 

    var copyFromSource = function (sourceChar) {
		invalidateCanvas();
		if (sourceChar.cbmCharRows.length > 0)
		{
			for (var i=0; i < gCharHeight; i++)
			{
				this.cbmCharRows[i] = sourceChar.cbmCharRows[i];
			}
		}

		// Memberwise copy
		this.IntendedMultiColor = sourceChar.IntendedMultiColor;
		this.IntendedCharColor = sourceChar.IntendedCharColor;

	};	 

	
    // Clear..
    var clear = function () {
	invalidateCanvas();
    for (var i = 0; i < gCharHeight; i++)
		this.cbmCharRows[i] = 0;
    };
	
    // Clear..
    var shiftUp = function () {
		RotateLeft(this.cbmCharRows);
	};

    // Clear..
    var shiftDown = function () {
		RotateRight(this.cbmCharRows);
		};	

    // Clear..
    var shiftLeft = function () {
		for (var row=0; row < gCharHeight; row++)
			this.cbmCharRows[row] = bitShiftLeft(this.cbmCharRows[row], 8);
		};	
	
	// Clear..
    var shiftRight = function () {
		for (var row=0; row < gCharHeight; row++)
			this.cbmCharRows[row] = bitShiftRight(this.cbmCharRows[row], 8);
		};
		
	// Clear..
    var flipHorz = function () {
		for (var row=0; row < gCharHeight; row++)
			if (this.IntendedMultiColor)
			{
				var clone = this.clone();
				this.setBit(row, 1, clone.getBit(row, 7));
				this.setBit(row, 0, clone.getBit(row, 6));
				this.setBit(row, 3, clone.getBit(row, 5));
				this.setBit(row, 2, clone.getBit(row, 4));
				this.setBit(row, 5, clone.getBit(row, 3));
				this.setBit(row, 4, clone.getBit(row, 2));
				this.setBit(row, 7, clone.getBit(row, 1));
				this.setBit(row, 6, clone.getBit(row, 0));
			}
			else
			{
					this.cbmCharRows[row] = bitReverse8(this.cbmCharRows[row]) ;
			}
	};
		
    var flipVert = function () {
		this.cbmCharRows.reverse();
		};
    
 	
	var getBits = function() {
		
		var bits = arrayFilled(8, gCharHeight, 0);
		for (var row = 0; row < gCharHeight; row++)
			for (var col=0; col < 8; col++){
				var curVal = getBit.bind(this)(row,col);				
				bits[row][col] = curVal;
			}
		return bits;
	}


	var setBits = function(matrix) {
		for (var row = 0; row < gCharHeight; row++)
			for (var col=0; col < 8; col++){
				var bit = matrix[row][col];
				setBit.bind(this)(row,col,bit);
			}
	}


	function revHelper(a){
	  for (i in a){
		a[i] = a[i].reverse();
	  }
	  return a;
	  }
	
	function invalidateCanvas(){
		
		if (this._Canvas)
			this._Canvas.width = 0;
		
	}
	
	function rotate90(a){
	invalidateCanvas();
	  a = Object.keys(a[0]).map(function (c) { return a.map(function (r) { return r[c]; }); });
	  a = revHelper(a);
	  return a;
	}

	function rotateNeg90(a){
	invalidateCanvas();
	  a = revHelper(a);
	  a = Object.keys(a[0]).map(function (c) { return a.map(function (r) { return r[c]; }); });
	  return a;
	}
	
	var arrayFilled = function (width, height, value) {
		for (var a = []; a.length < height;) {
			for (var r = []; r.length < width;) {
				r.push(value);
			}
			a.push(r);
		}
		return a;
	};

	var rotatePlus90 = function () {
		var cur = getBits.bind(this)();
		var newBits = rotate90(cur);
		setBits.bind(this)(newBits);
		};

    var rotateMinus90 = function () {
		var cur = getBits.bind(this)();
		var newBits = rotateNeg90(cur);
		setBits.bind(this)(newBits);
		};
    			
	var invert = function () {
		invalidateCanvas();
		for (var row=0; row < gCharHeight; row++)
			this.cbmCharRows[row] = ~(this.cbmCharRows[row]);
	};

	var swapNibbles = function (nib1, nib2) {
		if (nib1 == nib2)
			return;
		var clone = this.clone();
		for (var row=0; row < gCharHeight; row++){
			for (var colIdx =0; colIdx < 4; colIdx++){
				var col = 2 * colIdx;
				var nibU = clone.getBit(row, col);
				var nibL = clone.getBit(row, col + 1);
				var nib = (nibU << 1) | nibL;
				if (nib == nib1) 
				{
					nib = nib2;
					var nib2U = (nib2 & 2) >> 1;
					var nib2L = nib2 & 1;
					this.setBit(row, col, nib2U);
					this.setBit(row, col+1,  nib2L);
				}
				else if (nib == nib2) 
				{
					nib = nib1;
					var nib1U = (nib1 & 2) >> 1;
					var nib1L = nib1 & 1;
					this.setBit(row, col, nib1U);
					this.setBit(row, col+1,  nib1L);
				}
			}
		}
	};

	var replaceNibbles = function (nib1, nib2) {
		if (nib1 == nib2)
			return;
		var clone = this.clone();
		for (var row=0; row < gCharHeight; row++){
			for (var colIdx =0; colIdx < 4; colIdx++){
				var col = 2 * colIdx;
				var nibU = clone.getBit(row, col);
				var nibL = clone.getBit(row, col + 1);
				var nib = (nibU << 1) | nibL;
				if (nib == nib1) 
				{
					nib = nib2;
					var nib2U = (nib2 & 2) >> 1;
					var nib2L = nib2 & 1;
					this.setBit(row, col, nib2U);
					this.setBit(row, col+1,  nib2L);
				}
			}
		}
	};	
	
	var revert = function () {
		invalidateCanvas();
		for (var row = 0; row < gCharHeight; row++)
			this.cbmCharRows[row] =  cbmCharData[this.charIndex*8+row];
		this.IntendedMultiColor = false;
		this.IntendedCharColor = 6;// Blue
		};
				
	var revertBits = function () {
		invalidateCanvas();
		for (var row = 0; row < gCharHeight; row++)
			this.cbmCharRows[row] =  cbmCharData[this.charIndex*8+row];
		};
		
	// Get a row...
    var getCbmUnMirroredRow = function (row) {
        if ((row < 0) || (row > gCharHeight))
            throw "Out of range";
        return this.cbmCharRows[row];
    };

    // Get a bit...
    var getBit = function (row, col) {
        checkRange(row, col);
        var data = this.cbmCharRows[row];
        var mask = (1 << 7-col);
        var set = 1;
        if ((data & mask) == 0)
            set = 0;
        return set;
    };

    var setBitMC = function (rowIdx, colIdx, colour) {
		// Only 4 bits
		colIdx = (colIdx >> 1) << 1;
	   
		// Bind setBit to this and call it...
		setBit.bind(this)(row,colIdx + 1, colour & 1);
		setBit.bind(this)(row,colIdx, ((colour & 2) >> 1) );
    };
	
    var toggleBit = function (row, col) {
		var toggles=[1,0];
		// Bind getBit to this and call it...
		var curVal = getBit.bind(this)(row,col);
		// Bind setBit to this and call it...
		setBit.bind(this)(row,col,toggles[curVal]);
    };
	
	var setBit = function (row, col,val) {

		invalidateCanvas();
		checkRange(row, col);
        var mask = 1 << 7-col;
        var data = this.cbmCharRows[row];
        if (val)
			data = data | mask;
		else
			data = data & ~mask;

		this.cbmCharRows[row] = data;
		return data;
    };

    var checkRange = function (row, col) {
        if ((row < 0) || (row > (gCharHeight-1)))
            throw "row out of range";
        if ((col < 0) || (col > 7))
            throw "col out of range";
    };

    // Closure Interface
    return {
		Index : Index,
		getCbmUnMirroredRow: getCbmUnMirroredRow,
        getBit: getBit,
        setBit: setBit,
		toggleBit: toggleBit,
		clear: clear,
		shiftUp: shiftUp,
		shiftDown: shiftDown,
		shiftLeft : shiftLeft,
		shiftRight : shiftRight,
		flipHorz : flipHorz,
		flipVert : flipVert,
		invert: invert,
		row : row,
		rows : rows,
		copy : copy,
		paste : paste,
		revert: revert,
		clone: clone,
		copyFromSource : copyFromSource,
		setData: setData,
		rotatePlus90 : rotatePlus90,
		rotateMinus90 :rotateMinus90,
		revertBits : revertBits,
		swapNibbles : swapNibbles,
		Canvas : Canvas,
		invalidateCanvas, invalidateCanvas
		
    };
}();

