function drawCharCanvas(canvas) {

	doDrawCharCanvas(canvas, gCurrentCanvasChar);
	UpdateModifiedCell(gCurrentCanvasChar);
}

var readbilityROM = [1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];

function doDrawCharCanvas(canvas, charIndex, useROM) {
	var context = canvas.getContext("2d");
	prepareCanvas(canvas, context, 8, gCharHeight);
	context.drawgrid = true;
	context.clearRect(0, 0, 8, gCharHeight);

	var cbmChar = uDCGen.getCbmChar(charIndex);
	cbmChar.invalidateCanvas();	    
	
	// Draw original characters if using ROM
	if (useROM)
	{
		var copiedChar = cbmChar.clone();
		copiedChar.revertBits();
		copiedChar.IntendedCharColor = readbilityROM[gBackColIdx];
		copiedChar.IntendedMultiColor = false;
		cbmChar = copiedChar;
	}

	var localFillStyles = gmcFillStyles.slice(0);
	var cssCol = gCharColours[cbmChar.IntendedCharColor];
	localFillStyles[2] = cssCol;
	
	var romFillStyles = ["white","","black",""];

	if (useROM)
	{
		blitCharBits(false, gCharGrid, romFillStyles, canvas, context, cbmChar, 0, 0, 8, gCharHeight);
	}
	else
	{
		blitCharBits(cbmChar.IntendedMultiColor, gCharGrid, localFillStyles, canvas, context, cbmChar, 0, 0, 8,gCharHeight);
	}
 }
 
 
function proceessCharMouseMove(e) {

 	if (mouseCaptured )
	{
		var coords = getCursorPosition(e);
		var canvas = e.target;
		var col = Math.floor(coords.x / canvas.width * 8);
		var row = Math.floor(coords.y / canvas.height * gCharHeight);

		//alert("Setting pixel: " + row + "," +col);
		var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
		var colReg = $("#mcDIV input[type='radio']:checked").val();

		// Right mouse button = background
		if (mouseDownEvent.which === 3)
			colReg = 0;

		var toggleMode  = e.type == "mouseup" && ($("#chkCharToggleMode").is(":checked"));         
			
		//function proceessCharMouseMove(canvas, row, col, charIndex, colorRegister, toggleMode, intendedCharColour) {
		doCharCanvasProceessCharMouseMove(row, col, gCurrentCanvasChar, colReg, toggleMode, gIntendedMultiColour, gCurrentCanvasChar);
	}

}

function doCharCanvasProceessCharMouseMove(row, col, charIndex, colReg, toggleMode, intendedCharColour, hintChar) {
	
	var cbmChar = uDCGen.getCbmChar(charIndex);

	if (!intendedCharColour)
	{
		if (toggleMode)
		{
			cbmChar.toggleBit(row,col);
		}
		else
		{
			cbmChar.setBit(row,col,colReg >> 1);
		}
	}
	else
	{
		// Find the left column wherever we clicked
		col = (col >> 1) << 1;
		if (!toggleMode)
		{
			// Set MSB in column 1
			cbmChar.setBit(row,col, (colReg >> 1) & 1);
			cbmChar.setBit(row,col+1,colReg & 1);
		}
		else
		{
			var hi = cbmChar.getBit(row,col);
			var lo = cbmChar.getBit(row,col+1);
			var combined = lo|(hi<<1);
			combined++;
			combined&=3;
			cbmChar.setBit(row,col, (combined >> 1) & 1);
			cbmChar.setBit(row,col+1,combined & 1);
		}
	}

	drawCharCanvas($("#charCanvas")[0]);
	var x = function UpdateUIFromChar(c){
		drawScreen($("#screenCanvas")[0], -1, -1, c);	
	};
	_deferedEventManager.addAction("UpdateUIFromChar", x, 4);
}

$("#charCanvas").mousemove(function(e) {
	//console.log("mousemove");
   
	proceessCharMouseMove(e);

});

$("#charCanvas").mousedown(function(e) {
	//console.log("mousedown");
	mouseCaptured = true;
	mouseDownEvent = e;
});

$("#charCanvas").mouseleave(function(e) {
	//console.log("mouseleave");
	mouseCaptured = false;
}); 

$("#charCanvas").mouseup(function(e) {
	//console.log("mouseup");
	if (mouseCaptured)
	{
		proceessCharMouseMove(e);
	}
	mouseCaptured = false;
});

// Disable context menu
$('#charCanvas').bind('contextmenu', function(e){
    return false;
}); 