
// Add the stylesheet to the header for BG colour
var $bgStyleCSS = $("<style type='text/css'>").appendTo('head'); 
var classToBGColorMap = {};
var classToFGColorMap = {};

//
function setCSSClassColour(classVal, newCol, fgCol){
	
	// Set background colour mappings for class
	classToBGColorMap[classVal] = newCol;
	
	// Set foreground colour mappings for class (if any) or default to black
	if (fgCol != null)
		classToFGColorMap[classVal] = fgCol;
	else
		classToFGColorMap[classVal] = undefined; // Remove the color attribute....
	
	
	var htmlLines = [];
	for(var propertyName in classToBGColorMap) {
		var cssText = "." + propertyName + " {background-color: " + classToBGColorMap[propertyName] + ";}";
		htmlLines.push(cssText);
	}

	for(var propertyName in classToFGColorMap) {
		var cssText = "." + propertyName + " {color: " + classToFGColorMap[propertyName] + ";}";
		htmlLines.push(cssText);
	}
    var newHTML = htmlLines.join(" \r\r\n");
	//console.log(newHTML);
	$bgStyleCSS.html(newHTML);
}