var palleteOrg = ["#000000","#ffffff","#782922","#87d6dd","#a95fb6","#56a049","#40318e", "#bfce73",       "#aa7448", "#eab488", "#b86962","#c7ffff", "#e99ff6", "#94e088", "#8071cc", "#feffb3"];
var palleteNewPAL = ["#000000","#FFFFFF","#B61F21","#4DF0FF","#B43FFF","#44E237","#1A34FF", "#DCD71B",       "#CA5400", "#E9B072", "#E79293","#9AF7FD", "#E09FFF", "#8FE493", "#8290FF", "#E5DE85"];
var palleteNewNTSC = ["#000000","#FFFFFF","#F91137","#35F9F6","#FF3CC6","#3CEDA9","#0F57F7", "#FEE963",       "#FB6244", "#FBBFDE", "#F3ACE5","#A8EADD", "#E6B8F7 ", "#ABDDA4", "#6AB3E7 ", "#F7DAA5"];
var pallets = [palleteOrg, palleteNewPAL, palleteNewNTSC];
var palIndex = 0;
var  palletUse = pallets[palIndex];

var autoSaveLocation = "v20Edit\\autosave";
var autoSaveEnabledLocation = "v20Edit\\autosaveEnabled";
var doAutoSave;

var readbilityMap = ["white",null,null,null,null,null,null,null];

function RotateLeft(arr)
{
	var topRow = arr.shift();
	arr.push(topRow);
	return arr;
}		

function RotateRight(arr)
{
	arr.reverse();
	RotateLeft(arr);
	arr.reverse();
	return arr;
}	

function bit_test(num,bit){
    return ((num>>bit) % 2 != 0)
}

function bit_set_bool(num,bit,bool){
    return num | 1<<bit;
}

function bit_set(num,bit){
    return num | 1<<bit;
}

function bit_clear(num,bit){
    return num & ~(1<<bit);
}

function bit_toggle(num,bit){
    return bit_test(num,bit)?bit_clear(num,bit):bit_set(num,bit);
}

function bitShiftLeft(val,width)
{
	var mask = 0x01 << (width-1);
	var shiftRegister = (val & mask) >>> width-1;
	//alert(shiftRegister);
	return (val << 1) | shiftRegister;
}

function bitShiftRight(val,width)
{
	var mask = 0x01 ;
	var shiftRegister = (val & mask) << width-1;
	//alert(shiftRegister);
	return (val >> 1) | shiftRegister;
}

function bitReverse8(val)
{
	return  ( 
			((val & 128) >> 7 ) | 
			((val & 64) >> 5  ) | 
			((val & 32) >> 3  ) | 
			((val & 16) >> 1  ) | 
			((val & 8) << 1   ) | 
			((val & 4) << 3   ) | 
			((val & 2) << 5   ) | 
			((val & 1) << 7   )         
			);
}




function blitCharBits(multiColour, grid, fillStyles, canvas, context, cbmChar, x, y) {
	
	// Pointer into colour registers for nonMC mode
	
	if (!multiColour)
	{
		var colRegIdxs = [0,2];
		for (var row = 0; row < gCharHeight; row++) {
			for (var col = 0; col < 8; col++) {
				var styleIndex = cbmChar.getBit(row, col);
				context.fillStyle = fillStyles[colRegIdxs[styleIndex]];
				//console.log(fillStyles[0], fillStyles[2]);
				context.fillRect(x + col, y + row, 1,  1);
				if (grid)
				{
					context.strokeStyle="grey";
					context.lineWidth=.05;
					context.strokeRect(x + col, y + row, 1,  1);
				}
				else
				{
					context.strokeStyle="white";
					context.lineWidth=0;				
				}
			}
		}
	}
	else
	{
		for (var row = 0; row < gCharHeight; row++) {
			for (var col = 0; col < 8; col+=2) {
				var MSB = cbmChar.getBit(row, col);
				var LSB = cbmChar.getBit(row, col + 1);
				var colorReg = (MSB << 1) + LSB;
				context.fillStyle = fillStyles[colorReg];
				context.fillRect(x + col, y + row, 2,  1);
				if (grid)
				{
					context.strokeStyle="grey";
					context.lineWidth=.05;
					context.strokeRect(x + col, y + row, 2,  1);
				}
				else
				{
					context.strokeStyle="white";
					context.lineWidth=0;				
				}
			}
		}	
	}
}

function prepareCanvas(canvas, context, xSize, ySize){
	context.setTransform(1, 0, 0, 1, 0, 0);
	var xScale = canvas.width / xSize;
	var yScale = canvas.height / ySize;
	//context.clearRect(0, 0, canvas.width, canvas.height);
	//console.log(CbmScreen.screenWidth, yScale);
	context.scale(xScale , yScale);
}

function LoadPreferedPalete() {

	var item = localStorage.getItem("v20Edit\\palete");
	if (item)
	{	
		palIndex = parseInt(item);
	}
	palletUse = pallets[palIndex];
	$('#palSelect').val(palIndex).trigger('change');		
}

function AddDropdownColours(initial, select, charOnly) {

	$(select).empty();
	
	AddDropdownColour(select, 0, "Black", palletUse[0]);
    AddDropdownColour(select, 1, "White", palletUse[1]);
    AddDropdownColour(select, 2, "Red", palletUse[2]);
    AddDropdownColour(select, 3, "Cyan", palletUse[3]);
    AddDropdownColour(select, 4, "Purple", palletUse[4]);
    AddDropdownColour(select, 5, "Green", palletUse[5]);
    AddDropdownColour(select, 6, "Blue", palletUse[6]);
    AddDropdownColour(select, 7, "Yellow", palletUse[7]);
    if (charOnly) 
	{
		// only add aditional colours for aux, border, screen
    }
	else
	{
		AddDropdownColour(select, 8, "Orange", palletUse[8]);
		AddDropdownColour(select, 9, "LightOrange", palletUse[9]);
		AddDropdownColour(select, 10, "Pink", palletUse[10]);
		AddDropdownColour(select, 11, "LightCyan", palletUse[11]);
		AddDropdownColour(select, 12, "LightPurple", palletUse[12]);
		AddDropdownColour(select, 13, "LightGreen", palletUse[13]);
		AddDropdownColour(select, 14, "LightBlue", palletUse[14]);
		AddDropdownColour(select, 15, "LightYellow",palletUse[15]);
	}	
	
	$(select)
    .val(initial)
    .trigger('change');		
};

function AddDropdownColour(select, valParam, colourText, optColorVal) {

	// default optColorVal if not specified
    if (!optColorVal) {
        optColorVal = colourText;
    }
    var opt = document.createElement("option");
    var optJQ = $(opt);
	// Assign text and value to Option object
	optJQ.text(colourText);
	optJQ.css("background-color", optColorVal);
	optJQ.val(valParam);
    select.options.add(opt);
	
	// Store in array for quick lookup
	gCharColours[valParam] = optColorVal;
};
 
function getCursorPosition(e) {
    /* returns Cell with .row and .column properties */
    var x;
    var y;
    if (e.pageX != undefined && e.pageY != undefined) {
        x = e.pageX;
        y = e.pageY;
    }
    else {
        x = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
        y = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
    }
	x -= e.target.offsetLeft;
    y -= e.target.offsetTop;
	return {x:x,y:y};
}

// Cache common vars
var gCharCanvas =  $("#charCanvas")[0];
var gScreenCanvas =  $("#screenCanvas")[0]
	

function RedrawScreen()
{
    uDCGen.clearDrawCaches();
	drawScreen(gScreenCanvas);
	RefreshTableCharCount();
}

function AdjustSelection(x,y, grow)
{
    var rectOld = CbmScreen.getSelectionRect();

	if (grow) 
		CbmScreen.inflateSelectionRect(x,y);
	else
		CbmScreen.offsetSelectionRect(x,y);
	
    var rectNow = CbmScreen.getSelectionRect();
	
	rectOld.top -=1;
	rectOld.left -=1;
	rectOld.width +=1;
	rectOld.height +=1;
	rectNow.top -=1;
	rectNow.left -=1;
	rectNow.width +=1;
	rectNow.height +=1;
	
	var width = rectNow.width - 1;
	var height = rectNow.height - 1;	

	var cusText = "" + rectNow.row + "," + rectNow.col + " (" + (width+1) + ":" + (height+1) + ")";
	$("#cursorPos").text(cusText);

	drawScreen(gScreenCanvas, undefined, undefined, undefined, rectOld);
	drawScreen(gScreenCanvas, undefined, undefined, undefined, rectNow);

	
}

function RedrawSelection()
{
    var rectDraw = CbmScreen.getSelectionRect();
	rectDraw.col -=1;
	rectDraw.top -=1;
	rectDraw.width +=1;
	rectDraw.height +=1;
	drawScreen(gScreenCanvas, undefined, undefined, undefined, rectDraw);
	RefreshTableCharCount();
}

function RedrawCanvas()
{
    drawCharCanvas(gCharCanvas);
}

function RedrawScreenAndCanvas()
{
    RedrawScreen();
    RedrawCanvas();

	for (var i = 0; i < maxScreens; i++)
	{
		CbmScreens[i].setSelectionRect(-1,-1,0,0);
	}	
}

jQuery.expr[':'].focus = function(elem) {
  return elem === document.activeElement && (elem.type || elem.href);
};

$("body").bind('copy', function() {
 if ($("#exportText #kbMap").is(":focus")) return;
 $("#copySelection").trigger('click');
  
}); 
$("body").bind('paste', function() {
 if ($("#exportText #kbMap").is(":focus")) return;
	$("#pasteSelection").trigger('click');
}); 
$("body").bind('cut', function() {
  if ($("#exportText #kbMap").is(":focus")) return;
  var cmd = '$("#clearSelection").click().trigger(' + "'click'" + ')';
  setTimeout( cmd,1 );
   $("#copySelection").trigger('click');
});


var mapDefault = "64:0,65:1,66:2,67:3,68:4,69:5,70:6,71:7,72:8,73:9,74:10,75:11,76:12,77:13,78:14,79:15,80:16,81:17,82:18,83:19,84:20,85:21,86:22,87:23,88:24,89:25,90:26,91:27,163:28,93:29,32:32,33:33,34:34,35:35,36:36,37:37,38:38,39:39,40:40,41:41,42:42,43:43,44:44,45:45,46:46,47:47,48:48,49:49,50:50,51:51,52:52,53:53,54:54,55:55,56:56,57:57,58:58,59:59,60:60,61:61,62:62,63:63,97:1,98:2,99:3,100:4,101:5,102:6,103:7,104:8,105:9,106:10,107:11,108:12,109:13,110:14,111:15,112:16,113:17,114:18,115:19,116:20,117:21,118:22,119:23,120:24,121:25,122:26";
var mapDefaultMixedCase = "64:64,65:65,66:66,67:67,68:68,69:69,70:70,71:71,72:72,73:73,74:74,75:75,76:76,77:77,78:78,79:79,80:80,81:81,82:82,83:83,84:84,85:85,86:86,87:87,88:88,89:89,90:90,91:27,163:28,93:29,32:32,33:33,34:34,35:35,36:36,37:37,38:38,39:39,40:40,41:41,42:42,43:43,44:44,45:45,46:46,47:47,48:48,49:49,50:50,51:51,52:52,53:53,54:54,55:55,56:56,57:57,58:58,59:59,60:60,61:61,62:62,63:63,97:1,98:2,99:3,100:4,101:5,102:6,103:7,104:8,105:9,106:10,107:11,108:12,109:13,110:14,111:15,112:16,113:17,114:18,115:19,116:20,117:21,118:22,119:23,120:24,121:25,122:26";

var mapRevDefault = "64:128,65:129,66:130,67:131,68:132,69:133,70:134,71:135,72:136,73:137,74:138,75:139,76:140,77:141,78:142,79:143,80:144,81:145,82:146,83:147,84:148,85:149,86:150,87:151,88:152,89:153,90:154,91:155,163:156,93:157,32:160,33:161,34:162,35:163,36:164,37:165,38:166,39:167,40:168,41:169,42:170,43:171,44:172,45:173,46:174,47:175,48:176,49:177,50:178,51:179,52:180,53:181,54:182,55:183,56:184,57:185,58:186,59:187,60:188,61:189,62:190,63:191,97:129,98:130,99:131,100:132,101:133,102:134,103:135,104:136,105:137,106:138,107:139,108:140,109:141,110:142,111:143,112:144,113:145,114:146,115:147,116:148,117:149,118:150,119:151,120:152,121:153,122:154";
var mapRevMixed = "64:192,65:193,66:194,67:195,68:196,69:197,70:198,71:199,72:200,73:201,74:202,75:203,76:204,77:205,78:206,79:207,80:208,81:209,82:210,83:211,84:212,85:213,86:214,87:215,88:216,89:217,90:218,91:155,163:156,93:157,32:160,33:161,34:162,35:163,36:164,37:165,38:166,39:167,40:168,41:169,42:170,43:171,44:172,45:173,46:174,47:175,48:176,49:177,50:178,51:179,52:180,53:181,54:182,55:183,56:184,57:185,58:186,59:187,60:188,61:189,62:190,63:191,97:129,98:130,99:131,100:132,101:133,102:134,103:135,104:136,105:137,106:138,107:139,108:140,109:141,110:142,111:143,112:144,113:145,114:146,115:147,116:148,117:149,118:150,119:151,120:152,121:153,122:154";

var altMap = null;
try
{
	altMap = window.localStorage["v20Edit\\altKeyMap"];
}
catch(e)
{
}


if (altMap)
{
	$("#kbMap").val(altMap);
}
else
{
	$("#kbMap").val(mapDefault);
}

// Default key map (ALL UPPER)
$('#altKeyMapSave').click(function(e) {
	localStorage["v20Edit\\altKeyMap"] = $("#kbMap").val();
});

// Default key map
$('#altKeyMapDefault').click(function(e) {
	$("#kbMap").val(mapDefault);
});

// Mixed case key map
$('#altKeyMapMixed').click(function(e) {
	$("#kbMap").val(mapDefaultMixedCase);
});

// Rev Key map
$('#altKeyMapRev').click(function(e) {
	$("#kbMap").val(mapRevDefault);
});

// Rev+Mixed key map
$('#altKeyMapRevMixed').click(function(e) {
	$("#kbMap").val(mapRevMixed);
});


$("body").keypress(function(e) {
	
	var mapKeyAr = $("#kbMap").val().split(",");
	if ($("#exportText #kbMap").is(":focus")) return;
	var evtobj = window.event? event : e
	var keyCode = (evtobj.keyCode ? evtobj.keyCode : evtobj.which);
    console.log ("keypress:" + keyCode);		
	  
	  // Firefox hack
	  if (is_firefox)
	  {
		  // Cursor keys handled by keyup
		  if (keyCode >= 37 && keyCode <= 40) return;
		  if (keyCode == 46) return;
		  
		  if (evtobj.ctrlKey)
		  {
			if ((keyCode == 99) || 
			  (keyCode == 120) || 
			  (keyCode == 121) || 
			  (keyCode == 122) )
			{
				e.preventDefault();
				return false;
			}
		  }
	   }	

	  // Ctrl + Z
	  if (keyCode == 26 && evtobj.ctrlKey)
	  {
		 $("#btnUndo").trigger('click');
		e.preventDefault();
		return false;
	   }
	  
	  // Ctrl + Y
	  if (keyCode == 25 && evtobj.ctrlKey)
	  {
		 $("#btnRedo").trigger('click');		 
		 return;
	   }
		 
	  // Enter
	  if (keyCode == 13)
	  {
		CbmScreen.newLine();
		RedrawScreen();
		return;
	  }	

	  var shiftedArray =[];
	  for(var i = 0; i < mapKeyAr.length; i++) {
		var left =  parseInt(mapKeyAr[i].split(":")[0]);	
		var right = 128 + parseInt(mapKeyAr[i].split(":")[1]);	
		var joined = left + ":" + right;
		shiftedArray[i] = joined;
	  }
	
	 shiftedArray.join();
	 console.log("Shifted array");
	 console.log(shiftedArray);
	  
	  // Extract char to use
	  var index = -1;
	  var keyLookup = keyCode+":";
	  for(var i = 0; i < mapKeyAr.length; i++) {
	     if(mapKeyAr[i].startsWith(keyLookup))
		 {
			index = parseInt(mapKeyAr[i].split(":")[1]);	
			break;
		}
	  }
	  
	  if (index >=0)
	  {
			var rectOld = CbmScreen.getSelectionRect();
			CbmScreen.keyDown(index, gIntendedCharColSelection);
			var rectNew = CbmScreen.getSelectionRect();
			drawScreen(gScreenCanvas, undefined, undefined, undefined, rectNew);	  
			drawScreen(gScreenCanvas, undefined, undefined, undefined, rectOld);
	  }
});

$("body").keyup(function(e) {
	if ($("#exportText #kbMap").is(":focus")) return;
	  var keyCode = (e.keyCode ? e.keyCode : e.which);
	 //console.log ("keyup:" + keyCode + "ctrl=" + e.ctrlKey);		
	
	 // Ctrl A
	 if (keyCode == 65 && e.ctrlKey)
	 {
		CbmScreen.selectAll();
		RedrawScreen();
		e.preventDefault();
		return false;
	 }

	 // Delete key
	 if (keyCode == 46 )
	 {
		$("#clearSelection").trigger('click');
		e.preventDefault();
		return false;
	 }

	 // Backspace
	 if (keyCode == 8 )
	 {
		CbmScreen.cursorPrev();
		CbmScreen.keyDown(32,0);
		CbmScreen.cursorPrev(-1,0);
		RedrawScreen();
	 }
	 
	switch(keyCode)
	{
		case 38: AdjustSelection( 0,-1, e.shiftKey);break;
		case 40: AdjustSelection( 0, 1, e.shiftKey);break;
		case 37: AdjustSelection(-1, 0, e.shiftKey);break;
		case 39: AdjustSelection( 1, 0, e.shiftKey);break;
	}
});

// char Bank selector handler
$("#charBank").change(function(e) {
	var bankOffsets = [0,128,256,384];
	gCurBankOffset = bankOffsets[$(this).val()];
	PopulateCharTable();
});

// background colour handler
$("#gBackGroundColourSelect").change(function(e) {

	gBackColIdx = $(this).find('option:selected').val();
	gmcFillStyles[0] = gCharColours[gBackColIdx];
	setCSSClassColour("bgCol", gmcFillStyles[0], readbilityMap[gBackColIdx]);

	RedrawScreenAndCanvas();
	RefreshModifiedTableImages();
});



// border colour handler
$("#gBorderColourSelect").change(function(e) {
	gBorderColIdx = $(this).find('option:selected').val();
	gmcFillStyles[1] = gCharColours[gBorderColIdx];
	setCSSClassColour("bdCol", gmcFillStyles[1], readbilityMap[gBorderColIdx]);
	RedrawScreenAndCanvas();
	RefreshModifiedTableImages();

});

// table row handler
$("#gAuxColourSelect").change(function(e) {
	gAuxColIdx = $(this).find('option:selected').val();
	gmcFillStyles[3] = gCharColours[gAuxColIdx];
	setCSSClassColour("auxCol", gmcFillStyles[3], readbilityMap[gAuxColIdx]);

	RedrawScreenAndCanvas();
	RefreshModifiedTableImages();
});

// Clear button handler
$("#clearChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.clear();
	RedrawScreenAndCanvas();
}); 

// ShiftUp
$("#shiftUpChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.shiftUp();
	RedrawScreenAndCanvas();
}); 

// ShiftDown
$("#shiftDownChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.shiftDown();
	RedrawScreenAndCanvas();
}); 

// ShiftLeft
$("#shiftLeftChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.shiftLeft();
	RedrawScreenAndCanvas();
}); 

// ShiftRight
$("#shiftRightChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.shiftRight();
	RedrawScreenAndCanvas();
}); 

// FlipHorz
$("#flipHorzChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.flipHorz();
	RedrawScreenAndCanvas();
}); 

// Rotate+90
$("#rotPlus90").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.rotatePlus90();
	RedrawScreenAndCanvas();
}); 


// Rotate-90
$("#rotMinus90").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.rotateMinus90();
	RedrawScreenAndCanvas();
}); 

// FlipVert
$("#flipVertChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.flipVert();
	RedrawScreenAndCanvas();
}); 

// FlipVert
$("#invertChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.invert();
	RedrawScreenAndCanvas();
}); 

// FlipVert
$("#revertChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.revert();
	$('#chkMultiColour').prop('checked', false).triggerHandler('change');
	$('#selectIntendedCharColour').val(6).triggerHandler('change');

	RedrawScreenAndCanvas();
}); 

// FlipVert
$("#copyChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.copy();
}); 
		
// FlipVert
$("#pasteChar").click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	// Update character data
	cbmChar.paste();
	// Reset UI based on changed data
	SetCurCharFocus(gCurrentCanvasChar);
	RedrawScreenAndCanvas();
}); 
		
// Export function
$("#exportChars").click(function(e) {
    var link = document.getElementById('downloadlink');
    $("#exportText")[0].value = cbmExport.generateExport();
	link.href = cbmExport.makeTextFile(exportText.value);
    link.style.display = 'inline-block';
}); 

// Export function
$("#exportTilemap").click(function(e) {
    var link = document.getElementById('downloadlink');
    $("#exportText")[0].value = cbmExport.generateTileMap();
	//link.href = cbmExport.makeTextFile(exportText.value);
   // link.style.display = 'inline-block';
}); 



// Export function
$("#importChars").click(function(e) {
	var text = $("#exportText")[0].value;
	cbmExport.importFile(text);
	RedrawScreenAndCanvas();	
	RefreshModifiedTableImages();
	ResetUndoSystem();

	if (!($("#chkSingleScreen").is(":checked")))
	{
		$("#screenNum").val(0).trigger('click');
	}
	
}); 

function initColourSystem(bgCol, brdrCol, auxCol, intendedChar) {
	
	AddDropdownColours(bgCol,$("#gBackGroundColourSelect")[0]);
    AddDropdownColours(brdrCol, $("#gBorderColourSelect")[0], true);
    AddDropdownColours(auxCol,$("#gAuxColourSelect")[0]);
    AddDropdownColours(intendedChar, $("#selectIntendedCharColour")[0], true);
}

function OnBodyLoad() {
	
    //var bgCol = localStorage["v20Edit\vic20BGCol"];
	// Hardcode to white for now..
	bgCol = "1";
	gBackColIdx = bgCol;
	gBorderColIdx = 3;
	gAuxColIdx = 2;
	gIntendedCharColSelection= 6;
	LoadPreferedPalete();
	
	PopulateCharTable();

    drawCharCanvas($("#charCanvas")[0]);
    drawScreen($("#screenCanvas")[0]);

	
	OnCheckMultiColorChanged();
	// Default initial mode to draw
	$('#btcModeSel')
    .val("0")
    .trigger('change');		
	
 	var chkShowAllSceenCharCount = localStorage["v20Edit\\chkShowAllSceenCharCount"];
	$("#chkShowAllSceenCharCount").prop('checked', chkShowAllSceenCharCount == "true" ? true : false);

	var useCharToggle = localStorage["v20Edit\\useCharToggle"];
	$("#chkCharToggleMode").prop('checked', useCharToggle == "true" ? true : false);
	
	doAutoSave = localStorage[autoSaveEnabledLocation];
	$("#chkAutoSave").prop('checked', doAutoSave == "true" ? true : false);

	if (TryLoadURI())
		return;

	if (doAutoSave == "true")
	{
		var autoSaveValue = localStorage.getItem(autoSaveLocation);	
		if (autoSaveValue)
		{
			cbmExport.importFile(autoSaveValue);	
			RedrawScreenAndCanvas();	
			RefreshModifiedTableImages();
			ResetUndoSystem();		
		}
	}
}



// Multicolour mode handler
function OnCheckMultiColorChanged() {
	
	gIntendedMultiColour = ($(this).is(":checked"));         

	if (gIntendedMultiColour)
	{
		jQuery("#l4btncbg").show();
		jQuery("#l4btncaux").show();
	}
	else
	{
		jQuery("#l4btncbg").hide();
		jQuery("#l4btncaux").hide();
	}
 	
	// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.IntendedMultiColor = gIntendedMultiColour;

	// Redraw canvas based on current character
	RedrawCanvas();
}

$('#chkMultiColour').change(OnCheckMultiColorChanged);


// intended colour handler
$("#selectIntendedCharColour").change(function(e) {
	var index = $(this).find('option:selected').val();
	var cssCol = gCharColours[index];
	gmcFillStyles[2] = cssCol;
	setCSSClassColour("chrCol", cssCol, readbilityMap[index]);
	gIntendedCharColSelection = index;
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	cbmChar.IntendedCharColor = gIntendedCharColSelection;
	RedrawCanvas();
});	

function updateTableRowsFromIntended(){
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	SetTableAttributesFromIntended(cbmChar.IntendedMultiColor, cbmChar.IntendedCharColor);
	RefreshModifiedTableImages();
}

// Multicolour mode handler
$('#chkMultiColour').click(function(e) {
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	SetTableAttributesFromIntended(cbmChar.IntendedMultiColor, cbmChar.IntendedCharColor);
	RefreshModifiedTableImages();
});

// Multicolour mode handler
$('#selectIntendedCharColour').click(function(e) {
	
	// TOdo: This modified everything
	var cbmChar = uDCGen.getCbmChar(gCurrentCanvasChar);
	SetTableAttributesFromIntended(cbmChar.IntendedMultiColor, cbmChar.IntendedCharColor);
	RefreshModifiedTableImages();
});

// ScreenGrid mode handler
$('#chkScreenGrid').change(function() {
	gScreenGrid = ($(this).is(":checked"));         
	RedrawScreen();
});

// Char Grid mode handler
$('#chkCharGrid').change(function() {
	gCharGrid = ($(this).is(":checked"));         
	RedrawCanvas();
});

// ScreenGrid mode handler
$('#cursorMode').change(function() {
	gCursorMode = parseInt($(this).val());
	//alert("Cursor Mode: " + gCursorMode) ;   
});

// ScreenGrid mode handler
$('#btnChooseFile').change(function(e) {
	//alert("File selected" + e.target.files[0]) ;   
	var reader = new FileReader();
	//alert(reader);
	reader.onload = function(e) {
		var rawData = reader.result;
		//alert(rawData);
		$("#exportText")[0].value = rawData;
	}	 
	reader.readAsText(e.target.files[0]);
});

// Select mode handler
$('#divCursorMode input').change(function() {
	gCursorMode = parseInt($(this).val());
	CbmScreen.setSelectionRect(-1,-1,0,0);
	RedrawScreen();
});

// ScreenGrid mode handler
$('#outputMode').change(function() {
	//alert($(this).val());
	RedrawScreen();
});

function RecreateScreen()
{
	createScreens();
}

// border colour handler
$("#screenRowCount, #screenColumnCount").change(function(e) {
	RecreateScreen();
	RedrawScreenAndCanvas();	
});


// Char Grid mode handler
$('#chkDoubleHeight').change(function () {
    var checked = ($(this).is(":checked"));
    gCharHeight = checked ? 16 : 8;
    uDCGen = new _uDCGen();
    RecreateScreen();
    RedrawScreenAndCanvas();
    RefreshModifiedTableImages(0);
});


var originalCanvasHeight = $('#screenCanvas').height();
var originalCanvasWidth = $('#screenCanvas').width();

var lastParentHeight = $('#screenDiv').height();
var lastPparentWidth = $('#screenDiv').width();


setInterval (function () {

    var parentHeight = $('#screenDiv').height();
    var parentWidth = $('#screenDiv').width();

    if (lastParentHeight != parentHeight) {
        $('#screenCanvas').height(parentHeight - 140);
        lastParentHeight = $('#screenDiv').height();
    }

    if (lastPparentWidth != parentWidth) {
        $('#screenCanvas').width(parentWidth - 30);
        lastPparentWidth = $('#screenDiv').width();
    }

}, 1000);

$(document).ready(function () {
    OnBodyLoad();
});

$("#screenNum").change(function() {
	showSelectedScreen();
	RedrawScreenAndCanvas();
});


$("#revertRows").click(function(e) {
    var rows = $('#charTable tr');
	 $.each(rows, function( index, value ) {

		// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
		if ($(this).hasClass('highlight'))
		{
			var cbmChar = uDCGen.getCbmChar(index -1);
			cbmChar.revert();
		}
	});
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);
}); 



$("#invertRows").click(function(e) {
    var rows = $('#charTable tr');
	 $.each(rows, function( index, value ) {

		// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
		if ($(this).hasClass('highlight'))
		{
			var cbmChar = uDCGen.getCbmChar(index -1);
			cbmChar.invert();
		}
	});
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);
}); 



function mcSwap(nib1, nib2)
{
    var rows = $('#charTable tr');
	 $.each(rows, function( index, value ) {

		// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
		if ($(this).hasClass('highlight'))
		{
			var cbmChar = uDCGen.getCbmChar(index -1);
			cbmChar.swapNibbles(nib1, nib2);			
		}
	});
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);
}


function doToggle(control, toggleFunc, nib1, nib2 ) {
	
	if (control.lastToggle == null) 
		control.lastToggle = false;
	if (control.lastToggle)
		toggleFunc(nib1, nib2);
	else
		toggleFunc(nib2, nib1);
	control.lastToggle = !(control.lastToggle);
}

$("#swapBGBC").click(function(e) { doToggle ($("#swapBGBC")[0], mcSwap, 0,1)  }); 
$("#swapBGCHAR").click(function(e) { doToggle ($("#swapBGCHAR")[0], mcSwap, 0,2)  }); 
$("#swapBGAUX").click(function(e) { doToggle ($("#swapBGAUX")[0], mcSwap, 0,3)  }); 
$("#swapBCCHAR").click(function(e) { doToggle ($("#swapBCCHAR")[0], mcSwap, 1,2)  }); 
$("#swapBCAUX").click(function(e) { doToggle ($("#swapBCAUX")[0], mcSwap, 1,3)  }); 
$("#swapCHARAUX").click(function(e) { doToggle ($("#swapCHARAUX")[0], mcSwap, 2,3)  }); 

var rowCopyBuffer = [];

$("#copyRows").click(function(e) {
	
	rowCopyBuffer = [];
	/* Get all rows from your 'table' but not the first one 
     * that includes headers. */
     var rows = $('#charTable tr');
	 $.each(rows, function( index, value ) {

		// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
		if ($(this).hasClass('highlight'))
		{
			var cbmChar = uDCGen.getCbmChar(index -1);
			var clone = cbmChar.clone();
			rowCopyBuffer.push(clone);
		}
	});
}); 

$("#pasteRows").click(function(e) {
	 
	for (var i=0; i < rowCopyBuffer.length; i++)
	{
		var targetChar = uDCGen.getCbmChar(gCurrentCanvasChar + i);
		targetChar.copyFromSource(rowCopyBuffer[i]);
	}
	
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);

}); 

$("#smartPasteRows").click(function(e) {
	 
	_CbmScreenArray.prepareRelocate();
	
	for (var i=0; i < rowCopyBuffer.length; i++)
	{
		var targetChar = uDCGen.getCbmChar(gCurrentCanvasChar + i);
		var sourceChar = rowCopyBuffer[i];
		targetChar.copyFromSource(sourceChar);
		_CbmScreenArray.relocate(sourceChar.Index(), targetChar.Index());
	}
	
	
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);
	
}); 


$("#smartSwapPair").click(function(e) {
	 
	var selectedPair = getSelectedPair();
	if (!selectedPair)
		return;

	var index1 = selectedPair.index1;
	var index2 = selectedPair.index2;
	var originalCharBuffer = [];
	
	// Copy current characters
	for(var c=0; c<= 255; c++){
		var cbmChar = uDCGen.getCbmChar(c);
		var clone = cbmChar.clone();
		originalCharBuffer[c]=clone;
	}
	
	_CbmScreenArray.prepareRelocate();
	
	var targetChar = uDCGen.getCbmChar(index1);
	var sourceChar = originalCharBuffer[index2];
	targetChar.copyFromSource(sourceChar);
	_CbmScreenArray.relocate(sourceChar.Index(), targetChar.Index());
	
	var targetChar = uDCGen.getCbmChar(index2);
	var sourceChar = originalCharBuffer[index1];
	targetChar.copyFromSource(sourceChar);
	_CbmScreenArray.relocate(sourceChar.Index(), targetChar.Index());
	
	
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);

}); 



$("#clearRows").click(function(e) {
	 
    var rows = $('#charTable tr');
	 $.each(rows, function( index, value ) {

		// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
		if ($(this).hasClass('highlight'))
		{
			var cbmChar = uDCGen.getCbmChar(index -1);
			cbmChar.clear();
		}
	});
	RefreshModifiedTableImages();
	RedrawScreenAndCanvas();
	SetCurCharFocus(gCurrentCanvasChar);
	
}); 


$("#selectAllRows").click(function(e) {
    var rows = $('#charTable tr').not(':first');
	rows.addClass('highlight');
}); 

$("#selectfromSreen").click(function(e) {

    var rows = $('#charTable tr').not(':first');
	rows.removeClass('highlight');

	var selRect = CbmScreen.getSelectionRect();
	if (selRect != null && selRect != undefined)
	{
		normaliseRect(selRect);
		var startRow = selRect.row;
		var startCol = selRect.col;
		var endRow = startRow + selRect.height;
		var endCol = startCol + selRect.width;

		for (var row = startRow; row <= endRow; row++ )
			for (var col = startCol; col <=	 endCol; col++ ){
			var charIndex = CbmScreen.getCharFromRowCol(row, col);
			$(rows[charIndex]).addClass('highlight');
		}
	}
}); 



function getSelectedPair(){

	var ix1 = -1;
	var ix2 = -1;
	
	/* Get all rows from your 'table' but not the first one 
     * that includes headers. */
     var rows = $('#charTable tr');
	 $.each(rows, function( index, value ) {

		// Insert new cells (<td> elements) at the 1st and 2nd position of the "new" <tr> element:
		if ($(this).hasClass('highlight'))
		{
			if (ix1 == -1)
			{
				ix1 = index -1;
			}
			else if (ix2 == -1)
			{
				ix2 = index -1;
			}			
		}
	});

	if (ix1 > -1 && ix2 > -1)
	{
		return {index1:ix1, index2:ix2};
	}
	return null;
}

$("#swapPair").click(function(e) {

	var selectedPair = getSelectedPair();
	if (!selectedPair)
		return;

	var index1 = selectedPair.index1;
	var index2 = selectedPair.index2;

	if (index1 > -1 && index2 > -1)
	{
		var cbmChar1 = uDCGen.getCbmChar(index1);
		var cbmChar2 = uDCGen.getCbmChar(index2);

		var cbmChar1Copy = cbmChar1.clone();
		var cbmChar2Copy = cbmChar2.clone();
		
		cbmChar1.copyFromSource(cbmChar2Copy);
		cbmChar2.copyFromSource(cbmChar1Copy);

		RefreshModifiedTableImages();
		RedrawScreenAndCanvas();
		SetCurCharFocus(gCurrentCanvasChar);
	
	}

	
}); 

$("#chkShowAllSceenCharCount").click(function() {
	localStorage["v20Edit\\chkShowAllSceenCharCount"] = ($(this).is(":checked")); 
	RefreshTableCharCount();
});

$("#chkCharToggleMode").click(function() {
	localStorage["v20Edit\\useCharToggle"] = ($(this).is(":checked")); 
});

$("#chkAutoSave").click(function() {
	localStorage[autoSaveEnabledLocation] = ($(this).is(":checked")); 
});

// ScreenGrid mode handler
$('#btnChooseMGFile').change(function(e) {
	miniPaintIO.Import(e.target.files[0]);
});

// ScreenGrid mode handler
$('#exportMiniPaint').click(function(e) {
	
	miniPaintIO.Export();

});

// ScreenGrid mode handler
$('#initMiniPaint').click(function(e) {
	
	miniPaintIO.initMiniPaintMode();


});

// ScreenGrid mode handler
$('#romBankSelect').change(function(e) {
	var index = $(this).find('option:selected').val();
	
	if (index == "0")
	{
		cbmCharData = cbmCharDataUpper;
	}
	else
	{
		cbmCharData = cbmCharDataLower;
	}
	
	RefreshModifiedTableImages();
});

// ScreenGrid mode handler
$('#revertALL').click(function(e) {
	
	$("#selectAllRows").trigger("click");
	$("#revertRows").trigger("click");
});



// ScreenGrid mode handler
$('#palSelect').change(function(e) {
	var index = parseInt($(this).find('option:selected').val());
	palletUse = pallets[index];
	initColourSystem(gBackColIdx, gBorderColIdx, gAuxColIdx, gIntendedCharColSelection);
	localStorage["v20Edit\\palete"] = index;
});

var newDrawing = false;
$( window ).unload(function() {
	if (doAutoSave && !newDrawing)
	{
		var autoSave = cbmExport.generateExport();
		localStorage[autoSaveLocation] = autoSave;
	}
});

// ScreenGrid mode handler
$('#startNewDrawing').click(function(e) {
	newDrawing = true;
	localStorage[autoSaveLocation] = "";
	localStorage.removeItem(autoSaveLocation);
	location.reload();
});

//$.getJSON('http://anyorigin.com/dev/get?url=https%3A//www.dropbox.com/s/bkh8qr53f69dnov/PooyanAll.txt%3Fraw%3D1&callback=?', function(data){
	//$("#exportText").val(data.contents);
	//alert(data.contents);	
//});

function TryLoadURI()
{
	var uri = window.location.search.substring(1);
	if (uri != null && uri.length > 0)
	{
		var decodedURI = decodeURIComponent(uri).substring(3);
		$('#dlUrlText').val(decodedURI);
		$('#dlUrlButton').trigger('click');
		
		// when the text has loaded, load to the display....
		$("#exportText").one("change", function() { 
		$("#importChars").trigger('click'); } );
	}
}

function getUrlParameter(sParam)
{
    var sPageURL = window.location.search.substring(1);
    var sURLVariables = sPageURL.split('&');
    for (var i = 0; i < sURLVariables.length; i++) 
    {
        var sParameterName = sURLVariables[i].split('=');
        if (sParameterName[0] == sParam) 
        {
            return sParameterName[1];
        }
    }
}     


// ScreenGrid mode handler
$('#dlUrlButton').click(function(e) {

	var loadedData="";
	var url = $('#dlUrlText').val();
	var encodedURI = encodeURI(url);
	//alert (encodedURI);
	
	var anyOriginTemplate = 'http://anyorigin.com/dev/get?url={url}&callback=?';
	var aoString = anyOriginTemplate.replace("{url}", encodedURI );
	//alert (aoString);

	$.getJSON(aoString, function(data){
		loadedData = data.contents;
		$("#exportText").val(loadedData);
		$("#exportText").trigger('change');
		//alert(loadedData);	
	});
	
	//alert(loadedData);	
	$("#exportText").val(loadedData);
	
});
